/**
 * NOTE: This class is auto generated by the swagger code generator program (3.0.22).
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */
package com.crosswordcybersecurity.api;

import com.crosswordcybersecurity.model.SearchRequestObject;
import com.crosswordcybersecurity.model.VcPolicyBody;
import io.swagger.annotations.*;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;

import javax.validation.Valid;

@javax.annotation.Generated(value = "io.swagger.codegen.v3.generators.java.SpringCodegen", date = "2021-02-18T15:30:15.088Z[Europe/London]")
@Api(value = "vcpolicy", description = "the vcpolicy API")
public interface VcpolicyApi {

    @ApiOperation(value = "Retrieve a VC Policy", nickname = "getVCPolicy", notes = "This operation returns precisely one VC policy to the request, or none (404 not found) i.e. there cannot be two entries in the policy database that have the same SearchRequestObject value.This API is publicly accessible, meaning that any VC holder can access and download any policy providing they know the SearchRequestObject reference to it.", response = VcPolicyBody.class, tags={ "VC Policy", })
    @ApiResponses(value = { 
        @ApiResponse(code = 200, message = "VC Profile", response = VcPolicyBody.class),
        @ApiResponse(code = 400, message = "Bad Request", response = String.class),
        @ApiResponse(code = 401, message = "Unauthorised", response = String.class),
        @ApiResponse(code = 404, message = "Not Found", response = String.class),
        @ApiResponse(code = 500, message = "Internal Server Error", response = String.class) })
    @RequestMapping(value = "/v1/vcpolicy/get",
        produces = { "application/json" },
        consumes = { "application/json" },
        method = RequestMethod.POST)
    ResponseEntity<VcPolicyBody> getVCPolicy(@ApiParam(value = "The body of the request contains the Policy Match JSON object" ,required=true )  @Valid @RequestBody SearchRequestObject body
);

    @ApiOperation(value = "Insert a VC Policy", nickname = "insertVCPolicy", notes = "This API allows the caller to insert a VC Policy into the Verifier’s policy database. This operation is idempotent. If the policy already exists it will be overwritten, if it does not exist, it will be created. The operation comprises two arguments, the policyMatch object which uniquely references  the VC Policy, and the VC Policy itself. The Policy Match reference is a  JSON object that contains either the action on the target resource that the policy is controlling, or a simple type/value string. The policy is any JSON object, allowing different policy syntaxes and semantics to be stored according to the VC eco-system implementation. The caller must have established a mutually authenticated TLS connection with the VC Policy database in order to insert the policy, otherwise it will be rejected (401 Unauthorised).", response = String.class, tags={ "VC Policy", })
    @ApiResponses(value = { 
        @ApiResponse(code = 200, message = "OK", response = String.class),
        @ApiResponse(code = 400, message = "Bad Request", response = String.class),
        @ApiResponse(code = 401, message = "Unauthorised", response = String.class),
        @ApiResponse(code = 500, message = "Internal Server Error", response = String.class) })
    @RequestMapping(value = "/v1/vcpolicy/insert",
        produces = { "application/json" },
        consumes = { "application/json" },
        method = RequestMethod.POST)
    ResponseEntity<String> insertVCPolicy(@ApiParam(value = "The body of the request contains the Policy Match JSON object and the VC Policy JSON object" ,required=true )  @Valid @RequestBody VcPolicyBody body
);

}

